/*
 * @(#)src/classes/sov/java/nio/ByteBufferAsLongBufferRL.java, nio, as142, 20090306 1.2.2.1
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM SDK, Java(tm) 2 Technology Edition, v1.4.2
 * (C) Copyright IBM Corp. 1998, 2004.
 *
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 * ===========================================================================
 * Copyright 2002 Sun Microsystems, Inc. All rights reserved.
 * ===========================================================================
 */


/*
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 061774  030603 pabbott Remove autogeneration of NIO source files.
 *
 */

package java.nio;

class ByteBufferAsLongBufferRL extends ByteBufferAsLongBufferL {

   ByteBufferAsLongBufferRL(ByteBuffer bb) {

      super(bb);

   }

   ByteBufferAsLongBufferRL(ByteBuffer bb, int mark, int pos, int lim, int cap, int off) {

      super(bb, mark, pos, lim, cap, off);

   }

   public LongBuffer slice() {
      int pos = this.position();
      int lim = this.limit();
      assert(pos <= lim);
      int rem = (pos <= lim ? lim - pos : 0);
      int off = (pos << 3) + offset;
      return new ByteBufferAsLongBufferRL(bb, -1, 0, rem, rem, off);
   }

   public LongBuffer duplicate() {
      return new ByteBufferAsLongBufferRL(
         bb,
         this.markValue(),
         this.position(),
         this.limit(),
         this.capacity(),
         offset);
   }

   public LongBuffer asReadOnlyBuffer() {

      return duplicate();

   }

   public LongBuffer put(long x) {

      throw new ReadOnlyBufferException();

   }

   public LongBuffer put(int i, long x) {

      throw new ReadOnlyBufferException();

   }

   public LongBuffer compact() {

      throw new ReadOnlyBufferException();

   }

   public boolean isDirect() {
      return bb.isDirect();
   }

   public boolean isReadOnly() {
      return true;
   }

   public ByteOrder order() {

      return ByteOrder.LITTLE_ENDIAN;

   }

}
